Subject: [Dime] RFC 3588 - fixed positioned session-ID AVPs

From: "David Lehmann" <[email-masked]>
Date: Tue, 31 Aug 2010 09:13:10 -0400

Hello,
 
In RFC 3588 (and 3588bis), messages with session IDs are defined with
the session ID AVPs with a fixed position which is immediately following
the header. (e.g. section 8.3.1)  However, this is in contradiction with
section 8.8 which states, "When present, the Session-Id SHOULD appear
immediately following the Diameter Header (see Section 3)."
 
By using "SHOULD", the spec is stating that the session-ID AVP could be
in any position in the message.

--

David Lehmann

Ulticom, Inc.

856-787-2952

---

From: "Glen Zorn" <[email-masked]>
Date: Tue, 31 Aug 2010 20:53:30 +0700

David Lehmann  <mailto:[mailto://[email-masked]%5d>
[mailto://[email-masked]] writes:

Hello,
Hello.
In RFC 3588 (and 3588bis), messages with session IDs are defined with the
session ID AVPs with a fixed position which is immediately following the
header. (e.g. section 8.3.1)  
Yes.
However, this is in contradiction with section 8.8 which states, "When
present, the Session-Id SHOULD appear immediately following the Diameter
Header (see Section 3)."
No.
By using "SHOULD", the spec is stating that the session-ID AVP could be in
any position in the message.

No, it is stating that the AVP could be in any position in some message.
The syntax of the existing messages in RFC 3588 is defined by the associated
BNF and in those messages the Session-Id AVP must immediately follow the
Diameter header.

Hope this helps.

 ~gwz

---

From: "David Lehmann" <[email-masked]>
Date: Tue, 31 Aug 2010 10:37:11 -0400

Glen,

That is not what the spec says.  At least, the wording is not clear and,
IMHO, is misleading.  In which "some message" can the session-id AVP be
in any position?

It seems to me that the wording in section 8.8 should be:  "When
present, the Session-Id MUST appear immediately following the Diameter
Header (see Section 3)."

--

David Lehmann

Ulticom, Inc.

856-787-2952

From: Glen Zorn [mailto:[email-masked]] 
Sent: Tuesday, August 31, 2010 9:54 AM
To: David Lehmann
Cc: [email-masked]
Subject: RE: [Dime] RFC 3588 - fixed positioned session-ID AVPs

David Lehmann [mailto://[email-masked]]
<mailto:[mailto://[email-masked]%5d>  writes:

Hello,
Hello.
the header. (e.g. section 8.3.1)  

No, it is stating that the AVP could be in any position in some message.
The syntax of the existing messages in RFC 3588 is defined by the
associated BNF and in those messages the Session-Id AVP must immediately
follow the Diameter header.

Hope this helps.

 ~gwz

---

From: Victor Fajardo <[email-masked]>
Date: Tue, 31 Aug 2010 11:52:09 -0400

Hi David,

On Tue, Aug 31, 2010 at 10:37 AM, David Lehmann <[email-masked]>wrote:

> IMHO, is misleading.  In which “*some* message” can the session-id AVP be
> in any position?
>
>
>
> It seems to me that the wording in section 8.8 should be:  “When present,
> the Session-Id MUST appear immediately following the Diameter Header (see
> Section 3).”
>

As Glen has mentioned, the BNF dictates the positioning of the AVP. If you
add this text you are adding new rules beyond the BNF.

regards,
victor

>
>
> --
>
> *David Lehmann*
>
> Ulticom, Inc.
>
> 856-787-2952
>
>
>
> *From:* Glen Zorn [mailto:[email-masked]]
> *Sent:* Tuesday, August 31, 2010 9:54 AM
> *To:* David Lehmann
> *Cc:* [email-masked]
> *Subject:* RE: [Dime] RFC 3588 - fixed positioned session-ID AVPs
>
>
>
> David Lehmann [mailto://[email-masked]] <[mailto://[email-masked]%5d> writes:
>
> Hello,
>
> Hello.
>
> In RFC 3588 (and 3588bis), messages with session IDs are defined with the session ID AVPs with a fixed position which is immediately following the header. (e.g. section 8.3.1)
>
> Yes.
>
> However, this is in contradiction with section 8.8 which states, “When present, the Session-Id SHOULD appear immediately following the Diameter Header (see Section 3).”
>
> No.
>
> By using “SHOULD”, the spec is stating that the session-ID AVP could be in any position in the message.
>
> No, it is stating that the AVP could be in any position in *some*message.  The syntax of the existing messages in RFC 3588 is defined by the
> associated BNF and in *those* messages the Session-Id AVP *must*immediately follow the Diameter header.
>
>
>
>
>
> Hope this helps.
>
>
>
>  ~gwz
>
> _______________________________________________
> DiME mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/dime
>
>

---

From: "David Lehmann" <[email-masked]>
Date: Tue, 31 Aug 2010 13:54:09 -0400

The existing text in 8.8 is contradicting the BNF.  I am suggesting text
that agrees and supports the BNF.  

If you don't want to modify the text to agree with the BNF, then I
suggest removing the existing text which contradicts it.

--

David Lehmann

Ulticom, Inc.

856-787-2952

From: Victor Fajardo [mailto:[email-masked]] 
Sent: Tuesday, August 31, 2010 11:52 AM
To: David Lehmann
Cc: Glen Zorn; [email-masked]
Subject: Re: [Dime] RFC 3588 - fixed positioned session-ID AVPs

Hi David,

On Tue, Aug 31, 2010 at 10:37 AM, David Lehmann <[email-masked]>
wrote:

Glen,

As Glen has mentioned, the BNF dictates the positioning of the AVP. If
you add this text you are adding new rules beyond the BNF.

regards,

victor

	 

	--

	David Lehmann

	Ulticom, Inc.

	856-787-2952

	

	
	
	Hello,
	Hello.
	In RFC 3588 (and 3588bis), messages with session IDs are defined
with the session ID AVPs with a fixed position which is immediately
following the header. (e.g. section 8.3.1)  
	Yes.
	However, this is in contradiction with section 8.8 which states,
"When present, the Session-Id SHOULD appear immediately following the
Diameter Header (see Section 3)."
	No.
	By using "SHOULD", the spec is stating that the session-ID AVP
could be in any position in the message.

	No, it is stating that the AVP could be in any position in some
message.  The syntax of the existing messages in RFC 3588 is defined by
the associated BNF and in those messages the Session-Id AVP must
immediately follow the Diameter header.

	Hope this helps.

	 ~gwz

---

From: Victor Fajardo <[email-masked]>
Date: Tue, 31 Aug 2010 14:20:40 -0400

On Tue, Aug 31, 2010 at 1:54 PM, David Lehmann <[email-masked]> wrote:

>  The existing text in 8.8 is contradicting the BNF.
>

 Which BNF though ? There maybe apps beyond 3588 that may not necessarily
put the session-id after the header in their BNF's. In that regard, the
existing text is not contradictory but is meant to be generalized specially
because it describes an AVP and is agnostic to any BNF.

my two cents,
victor

>  I am suggesting text that agrees and supports the BNF.
>
>
>
> If you don’t want to modify the text to agree with the BNF, then I suggest
> removing the existing text which contradicts it.
>
>
>
> --
>
> *David Lehmann*
>
> Ulticom, Inc.
>
> 856-787-2952
>
>
>
> *From:* Victor Fajardo [mailto:[email-masked]]
> *Sent:* Tuesday, August 31, 2010 11:52 AM
> *To:* David Lehmann
> *Cc:* Glen Zorn; [email-masked]
> *Subject:* Re: [Dime] RFC 3588 - fixed positioned session-ID AVPs
>
>
>
> Hi David,
>

---

From: "David Lehmann" <[email-masked]>
Date: Tue, 31 Aug 2010 15:22:27 -0400

So you are stating that the Diameter protocol itself does NOT require
all session-ID AVPs to follow immediately after the message header, but
a message's BNF may require it?  

--

David Lehmann

Ulticom, Inc.

856-787-2952

From: Victor Fajardo [mailto:[email-masked]] 
Sent: Tuesday, August 31, 2010 2:21 PM
To: David Lehmann
Cc: Glen Zorn; [email-masked]
Subject: Re: [Dime] RFC 3588 - fixed positioned session-ID AVPs

On Tue, Aug 31, 2010 at 1:54 PM, David Lehmann <[email-masked]>
wrote:

 

Which BNF though ? There maybe apps beyond 3588 that may not necessarily
put the session-id after the header in their BNF's. In that regard, the
existing text is not contradictory but is meant to be generalized
specially because it describes an AVP and is agnostic to any BNF.

my two cents,

victor

	If you don't want to modify the text to agree with the BNF, then
I suggest removing the existing text which contradicts it.

	--

	David Lehmann

	Ulticom, Inc.

	856-787-2952

	Hi David,

	On Tue, Aug 31, 2010 at 10:37 AM, David Lehmann
<[email-masked]> wrote:

	Glen,

	That is not what the spec says.  At least, the wording is not
clear and, IMHO, is misleading.  In which "some message" can the
session-id AVP be in any position?

	As Glen has mentioned, the BNF dictates the positioning of the
AVP. If you add this text you are adding new rules beyond the BNF.

	regards,

	victor

		 

		--

		David Lehmann

		Ulticom, Inc.

		856-787-2952

		From: Glen Zorn [mailto:[email-masked]] 
		Sent: Tuesday, August 31, 2010 9:54 AM
		To: David Lehmann
		Cc: [email-masked]
		Subject: RE: [Dime] RFC 3588 - fixed positioned
session-ID AVPs

		

		

		

		
		Hello,
		Hello.
		In RFC 3588 (and 3588bis), messages with session IDs are
defined with the session ID AVPs with a fixed position which is
immediately following the header. (e.g. section 8.3.1)  
		Yes.
		However, this is in contradiction with section 8.8 which
states, "When present, the Session-Id SHOULD appear immediately
following the Diameter Header (see Section 3)."
		No.
		By using "SHOULD", the spec is stating that the
session-ID AVP could be in any position in the message.

		No, it is stating that the AVP could be in any position
in some message.  The syntax of the existing messages in RFC 3588 is
defined by the associated BNF and in those messages the Session-Id AVP
must immediately follow the Diameter header.

		Hope this helps.

		 ~gwz

---

From: Victor Fajardo <[email-masked]>
Date: Tue, 31 Aug 2010 16:25:10 -0400

yes. the BNF sets the positioning/sequencing rules. it's a common
practice in BNFs to place session-id near the head to optimize msg
processing .. etc.

On Tue, Aug 31, 2010 at 3:22 PM, David Lehmann <[email-masked]> wrote:

>  So you are stating that the Diameter protocol itself does NOT require all
> session-ID AVPs to follow immediately after the message header, but a
> message’s BNF may require it?
>
>
>
> --
>
> *David Lehmann*
>
> Ulticom, Inc.
>
> 856-787-2952
>
>
>
> *Sent:* Tuesday, August 31, 2010 2:21 PM
>
> *To:* David Lehmann

---

From: "Glen Zorn" <[email-masked]>
Date: Wed, 1 Sep 2010 09:54:49 +0700

David Lehmann [mailto:[email-masked]] writes:
Glen,

That is not what the spec says.  

Actually, it's exactly what the spec says; please revisit RFC 2119 for the
definition of the key word "SHOULD".

At least, the wording is not clear and, IMHO, is misleading.  In which "some
message" can the session-id AVP be in any position?

Sorry, maybe I was unclear.  Let me try again: the definition of the
Session-Id AVP does not preclude the definition of a Diameter message in
which the Session-Id AVP does not immediately follow the Diameter header;
that (AFAIK) no such message currently exists is irrelevant.

It seems to me that the wording in section 8.8 should be:  "When present,
the Session-Id MUST appear immediately following the Diameter Header (see
Section 3)."

Why unnecessarily constrain the reuse of the AVP?

--

David Lehmann

Ulticom, Inc.

856-787-2952

 
Hello,
Hello.

 

Hope this helps.

 ~gwz

---

From: "Glen Zorn" <[email-masked]>
Date: Wed, 1 Sep 2010 10:27:23 +0700

David Lehmann [mailto:[email-masked]] writes:
So you are stating that the Diameter protocol itself does NOT require all
session-ID AVPs to follow immediately after the message header, but a
message's BNF may require it?  

That's what the RFC says, yes.

.